#ifndef BMUD_H
#define BMUD_H

#ifdef USE_GNOME
        #ifndef GNOME_H
        #include <gnome.h>
        #endif
#else
        #include <gtk/gtk.h>
#endif

#define MESSAGE_ERR     0
#define MESSAGE_NORMAL  1
#define MESSAGE_ANSI    2
#define MESSAGE_NONE    3

#define bool int:1

#define SERVERFILE "mudservers"

struct bmud_history{
	gchar **list;	/* the actual history */
	gchar *tmp;	/* in case something was typed before traverssing hist */
	int size;	/* current number of elements */
	int pos;	/* where to add */
	int cur;	/* which is displayed */
	int max;	/* total number of elements :) */
	int cyclic;	/* controls cyclic vs linear history */
};

typedef struct {
	GtkWidget *window, *menu, *text, *stat, *ent, *hostentry, *portentry, *vbox;

	GdkFont *disp_font;
	gchar *disp_font_name;
	GdkColor curr_color;

	struct bmud_history *hist;
	
	gint items;
	gint lines;
	gint maxlines;
}bmud;


		/***** FUNCTIONS *****/

	/* alias.c */
void do_alias(char *);

	/* color.c */
extern void show_colorm(void);
extern void init_colors();
extern void disp_ansi(int, gchar *, GtkWidget *);
extern int color_load();
extern int color_default();
extern int color_dump();
extern int color_save();

	/* eq.c    */
extern void show_eq(void);

	/* font.c  */
extern void show_fontsel(void);

	/* gui.c   */
extern GtkWidget *spawn_gui( void );
extern void textfield_add( gchar *, int);
extern void cbox(void);
extern void clist(void);
extern void clear(int,GtkText *);
extern void cleartail();
extern void init(int, char **);
extern void do_menu(GtkWidget *);
extern void do_about();
extern void destructify();

	/* main.c  */
extern bmud *mud;

	/* map.c   */
extern void  show_map(void);

	/* misc.c  */
extern void  check_my_dir();
extern char *show_conf_dir();
extern void  hist_add(char *);
extern gint  hist_evt(GtkWidget*,GdkEventKey*,gpointer);
extern void  hist_clear();

	/* net.c   */
extern void  make_connection ( char *host, char *port );
extern void  open_connection (  const char *host, const char *port );
extern void send_to_connection ( GtkWidget *, gpointer data );
extern void read_from_connection (gpointer, gint , GdkInputCondition );
extern void disconnect ( void );

	/* prefs.c */
extern int session_load();
extern int session_default();
extern int session_save();

	/* wiz.c   */
extern void show_wiz(void);


		/***** VARIABLES *****/
	/* alias.c */

	/* color.c */
extern GdkColor *foreground;

extern GdkColor color_white;
extern GdkColor color_black;
extern GdkColor color_red;

	/* gui.c   */
extern GtkWidget *win;

#endif

