/* handles ~/.bmud/prefs */

#include "bmud.h"
#include <stdio.h>

FILE *fp;

void session_scan()
{
	char flag[1024], value[1024];
	if(fscanf(fp,"%s %s",flag,value)!=2)return;	/* wasn't real */
	if(!strncmp(flag,"hist_max",8))mud->hist->max=atoi(value);
	else if(!strncmp(flag,"hist_cyclic",10))mud->hist->cyclic=atoi(value);
	else if(!strncmp(flag,"font_name",9))mud->disp_font_name=g_strdup(value);
	else if(!strncmp(flag,"max_lines",9))mud->maxlines=atoi(value);
	return;
}

int session_load()
{
	int x;
	char *confdir;

	confdir = show_conf_dir();
	
	mud->hist->size=0;
	mud->hist->cur=0;
	mud->hist->pos=0;
	mud->lines=0;
	
	if( confdir == NULL )
	{
		session_default();
		return 1;
	}
	
	if((fp=fopen(g_strconcat(confdir,"prefs",NULL),"r")) == NULL)
	{
		session_default();
		return 1;
	}
	while(!feof(fp))
		session_scan();
	fclose(fp);

	mud->hist->list = g_malloc( sizeof( void * ) * mud->hist->max);

	for(x=0;x<mud->hist->max;x++)
		mud->hist->list[x]=NULL;

	return 1;
}
	
int session_default()
{
	int x;
	
	textfield_add("Could not open prefs file, using defaults\n",MESSAGE_ERR);
	printf("Could not open prefs file, using defaults\n");
	
	mud->hist->max=20;
	mud->hist->cyclic=0;
	mud->disp_font_name="fixed";
	mud->maxlines=200*60;	/* roughly 60 bytes per line? */

	mud->hist->list = g_malloc( sizeof( void * ) * mud->hist->max);

	for(x=0;x<mud->hist->max;x++)
		mud->hist->list[x]=NULL;

	return 0;
}	
	
int session_save()
{
	char *tmp, *confdir;

	confdir = show_conf_dir();
	
	textfield_add("Saving session\n",MESSAGE_ERR);
	printf("Saving session\n");
	
	if((confdir == NULL) || ((fp=fopen(g_strconcat(confdir,"prefs",NULL),"w"))==NULL))
	{
		textfield_add("Unabled to open prefs file for writing\n",MESSAGE_ERR);
		printf("Unabled to open prefs file for writing\n");
		return -1;
	}

	fprintf(fp,"hist_max %d\n",mud->hist->max);
	fprintf(fp,"hist_cyclic %d\n",mud->hist->cyclic);
	fprintf(fp,"font_name %s\n",mud->disp_font_name);
	fprintf(fp,"max_lines %d\n",mud->maxlines);

/*		window position stuff someday?
	sprintf(tmp,"%dx%d",mud->window
	fprintf(fp,"window_position %s",tmp);
	sprintf(tmp,"%dx%d",mud->window-
*/
	
	fclose(fp);

	return 0;
}
